# Method: projects.image.computePixels

Computes a tile of pixels by performing an arbitrary computation on image data.

Requests are limited to 48MB in uncompressed data per request, computed as the product of the request dimensions in pixels, the number of image bands requested, and the number of bytes per pixel for each band. Requests are also limited to at most 32K pixels in either dimension and at most 1024 bands. Requests exceeding these limits will result in an error code of 400 (BAD_REQUEST).

If successful, the response body contains the requested pixel data in the encoding specified in the `fileFormat` field of the request.

### HTTP request

`POST https://earthengine.googleapis.com/v1beta/{project=projects/*}/image:computePixels`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` The project id or project number of the Google Cloud Platform project that should be treated as the service consumer for this request. Format is `projects/{project-id}`. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `project`: - `earthengine.computations.create` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "expression": { object (`https://developers.google.com/earth-engine/reference/rest/v1beta/Expression`) }, "fileFormat": enum (`https://developers.google.com/earth-engine/reference/rest/v1beta/ImageFileFormat`), "grid": { object (`https://developers.google.com/earth-engine/reference/rest/v1beta/PixelGrid`) }, "bandIds": [ string ], "visualizationOptions": { object (`https://developers.google.com/earth-engine/reference/rest/v1beta/VisualizationOptions`) }, "workloadTag": string } ``` |

| Fields ||
|---|---|
| `expression` | ``object (`https://developers.google.com/earth-engine/reference/rest/v1beta/Expression`)`` The expression to compute. |
| `fileFormat` | ``enum (`https://developers.google.com/earth-engine/reference/rest/v1beta/ImageFileFormat`)`` The output file format in which to return the pixel values. |
| `grid` | ``object (`https://developers.google.com/earth-engine/reference/rest/v1beta/PixelGrid`)`` Parameters describing how the image computed by `expression` should be reprojected and clipped. If not present, the full computed image is returned in its native projection. |
| `bandIds[]` | `string` If present, specifies a specific set of bands that will be selected from the result of evaluating `expression`. If not present, all bands resulting from `expression` will be selected. |
| `visualizationOptions` | ``object (`https://developers.google.com/earth-engine/reference/rest/v1beta/VisualizationOptions`)`` If present, a set of visualization options to apply to produce an 8-bit RGB visualization of the data. |
| `workloadTag` | `string` User supplied tag to track this computation. |

### Response body

If successful, the response is a generic HTTP response whose format is defined by the method.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/earthengine`
- `
  https://www.googleapis.com/auth/earthengine.readonly`
- `
  https://www.googleapis.com/auth/cloud-platform`
- `
  https://www.googleapis.com/auth/cloud-platform.read-only`

For more information, see the [OAuth 2.0 Overview](https://developers.google.com/identity/protocols/OAuth2).